searchNodes=[{"doc":"Use :atomics as a bit array or as an array of N-bit counters. Erlang atomics documentation The Abit module (this module) has functions to use :atomics as a bit array. The bit array is zero indexed. The Abit.Counter module has functions to use :atomics as an array of N-bit counters. The Abit.Bitmask functions help working with bitmasks. Abit iex&gt; ref = :atomics . new ( 100 , signed : false ) iex&gt; Abit . bit_count ( ref ) 6400 iex&gt; Abit . bit_at ( ref , 0 ) 0 iex&gt; Abit . set_bit_at ( ref , 0 , 1 ) :ok iex&gt; Abit . bit_at ( ref , 0 ) 1 Abit.Counter iex&gt; counter = % Abit.Counter { } = Abit.Counter . new ( 100 , 16 ) iex&gt; Abit.Counter . get ( counter , 0 ) 0 iex&gt; Abit.Counter . put ( counter , 0 , 100 ) { :ok , { 0 , 100 } } iex&gt; Abit.Counter . add ( counter , 0 , 100 ) { :ok , { 0 , 200 } } iex&gt; Abit.Counter . member? ( counter , 200 ) true Abit.Bitmask iex&gt; Abit.Bitmask . set_bits_count ( 3 ) 2 iex&gt; Abit.Bitmask . bit_at ( 2 , 0 ) 0 iex&gt; Abit.Bitmask . bit_at ( 2 , 1 ) 1","ref":"Abit.html","title":"Abit","type":"module"},{"doc":"Returns bit at bit_index in atomic ref . Examples iex&gt; ref = :atomics . new ( 1 , signed : false ) iex&gt; ref |&gt; :atomics . put ( 1 , 3 ) iex&gt; Abit . bit_at ( ref , 0 ) 1 iex&gt; Abit . bit_at ( ref , 1 ) 1 iex&gt; Abit . bit_at ( ref , 2 ) 0","ref":"Abit.html#bit_at/2","title":"Abit.bit_at/2","type":"function"},{"doc":"Returns total count of bits in atomics ref . :atomics are 64 bit integers so total count of bits is size * 64. Examples iex&gt; ref = :atomics . new ( 1 , signed : false ) iex&gt; Abit . bit_count ( ref ) 64 iex&gt; ref2 = :atomics . new ( 2 , signed : false ) iex&gt; Abit . bit_count ( ref2 ) 128","ref":"Abit.html#bit_count/1","title":"Abit.bit_count/1","type":"function"},{"doc":"Returns position of bit in :atomics . Returns a 2 tuple containing: atomics_index - the index of the integer in atomics where the bit is located bit_index - the index of the bit in the integer Examples iex&gt; Abit . bit_position ( 0 ) { 1 , 0 } iex&gt; Abit . bit_position ( 11 ) { 1 , 11 } iex&gt; Abit . bit_position ( 64 ) { 2 , 0 }","ref":"Abit.html#bit_position/1","title":"Abit.bit_position/1","type":"function"},{"doc":"Returns the bitwise hamming distance between the two given :atomics references ref_l and ref_r . Raises ArgumentError if the size of ref_l and ref_r don't equal. Examples iex&gt; ref_l = :atomics . new ( 10 , signed : false ) iex&gt; ref_r = :atomics . new ( 10 , signed : false ) iex&gt; Abit . hamming_distance ( ref_l , ref_r ) 0 iex&gt; ref_l |&gt; :atomics . put ( 1 , 7 ) iex&gt; Abit . hamming_distance ( ref_l , ref_r ) 3","ref":"Abit.html#hamming_distance/2","title":"Abit.hamming_distance/2","type":"function"},{"doc":"Bit intersection of atomics using Bitwise AND operator. Returns ref_a mutated.","ref":"Abit.html#intersect/2","title":"Abit.intersect/2","type":"function"},{"doc":"Merge bits of atomics ref_a &amp; ref_b using the bitwise OR operator. ref_b will be merged into ref_a . Returns ref_a mutated.","ref":"Abit.html#merge/2","title":"Abit.merge/2","type":"function"},{"doc":"Sets the bit at bit_index to bit in the atomics ref . Returns :ok . Examples iex&gt; ref = :atomics . new ( 1 , signed : false ) iex&gt; ref |&gt; Abit . set_bit_at ( 0 , 1 ) iex&gt; ref |&gt; :atomics . get ( 1 ) 1 iex&gt; ref |&gt; Abit . set_bit_at ( 0 , 0 ) :ok iex&gt; ref |&gt; :atomics . get ( 1 ) 0","ref":"Abit.html#set_bit_at/3","title":"Abit.set_bit_at/3","type":"function"},{"doc":"Returns number of bits set to 1 in atomics array ref . Examples iex&gt; ref = :atomics . new ( 1 , signed : false ) iex&gt; ref |&gt; :atomics . put ( 1 , 3 ) iex&gt; Abit . set_bits_count ( ref ) 2 iex&gt; ref2 = :atomics . new ( 1 , signed : false ) iex&gt; Abit . set_bits_count ( ref2 ) 0","ref":"Abit.html#set_bits_count/1","title":"Abit.set_bits_count/1","type":"function"},{"doc":"Returns a flat list of every atomic value converted into a list of bits from ref atomics reference. Examples ref = :atomics . new ( 10 , signed : false ) ref |&gt; Abit . to_list [ 0 , 0 , 0 , 0 , 0 , ... ]","ref":"Abit.html#to_list/1","title":"Abit.to_list/1","type":"function"},{"doc":"Functions for working with bits &amp; integer bitmasks.","ref":"Abit.Bitmask.html","title":"Abit.Bitmask","type":"module"},{"doc":"Returns bit at bit_index in the given integer . Examples iex&gt; Abit.Bitmask . bit_at ( 2 , 0 ) 0 iex&gt; Abit.Bitmask . bit_at ( 2 , 1 ) 1 iex&gt; Abit.Bitmask . bit_at ( 1 , 0 ) 1 iex&gt; Abit.Bitmask . bit_at ( 0 , 0 ) 0","ref":"Abit.Bitmask.html#bit_at/2","title":"Abit.Bitmask.bit_at/2","type":"function"},{"doc":"Returns the bitwise hamming distance between the given integers int_l and int_r . Examples iex&gt; Abit.Bitmask . hamming_distance ( 1 , 1 ) 0 iex&gt; Abit.Bitmask . hamming_distance ( 1 , 0 ) 1 iex&gt; Abit.Bitmask . hamming_distance ( 1 , 1023 ) 9 iex&gt; Abit.Bitmask . hamming_distance ( 1 , 1024 ) 2","ref":"Abit.Bitmask.html#hamming_distance/2","title":"Abit.Bitmask.hamming_distance/2","type":"function"},{"doc":"Sets the bit at bit_index in integer and returns it. Examples iex&gt; Abit.Bitmask . set_bit_at ( 1 , 0 , 0 ) 0 iex&gt; Abit.Bitmask . set_bit_at ( 0 , 0 , 1 ) 1 iex&gt; Abit.Bitmask . set_bit_at ( 0 , 2 , 1 ) 4","ref":"Abit.Bitmask.html#set_bit_at/3","title":"Abit.Bitmask.set_bit_at/3","type":"function"},{"doc":"Returns the count of bits set to 1 in the given integer int . Examples iex&gt; Abit.Bitmask . set_bits_count ( 3 ) 2 iex&gt; Abit.Bitmask . set_bits_count ( 0 ) 0 iex&gt; Abit.Bitmask . set_bits_count ( 1024 ) 1 iex&gt; Abit.Bitmask . set_bits_count ( 1023 ) 10","ref":"Abit.Bitmask.html#set_bits_count/1","title":"Abit.Bitmask.set_bits_count/1","type":"function"},{"doc":"Converts the given integer to a list of bits. size is the size of the bitstring you want the integer to be converted to before creating a list from it. Examples iex&gt; Abit.Bitmask . to_list ( 1 , 1 ) [ 1 ] iex&gt; Abit.Bitmask . to_list ( 1 , 2 ) [ 0 , 1 ] iex&gt; Abit.Bitmask . to_list ( 214311324231232211111 , 64 ) [ 1 , 0 , 0 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 1 , 0 , 1 , 0 , 1 , 0 , 1 , 1 , 0 , 0 , 0 , 1 , 0 , 1 , 1 , 1 , 1 , 0 , 1 , 0 , 1 , 1 , 0 , 0 , 0 , 1 , 0 , 0 , 1 , 0 , 0 , 0 , 1 , 0 , 1 , 0 , 0 , 1 , 0 , 1 , 0 , 0 , 1 , 0 , 0 , 0 , 1 , 0 , 1 , 0 , 0 , 1 , 1 , 1 ]","ref":"Abit.Bitmask.html#to_list/2","title":"Abit.Bitmask.to_list/2","type":"function"},{"doc":"Use :atomics as an array of counters with N bits per counter. An :atomics is an array of 64 bit integers so the possible counters are below: Possible counters: bits | unsigned value range | signed value range 2 | 0 .. 3 | - 2 .. 1 4 | 0 .. 15 | - 8 .. 7 8 | 0 .. 255 | - 128 .. 127 16 | 0 .. 65535 | - 32768 .. 32767 32 | 0 .. 4294967295 | - 2147483648 .. 2147483647 If you need 64 bit counters use Erlang counters The option :wrap_around is set to false by default. With these small-ish counters this is a safe default. When :wrap_around is false using put/3 or add/3 when the value would be out of bounds the error tuple {:error, :value_out_of_bounds} will be returned and the stored counter value will not change. While Erlang :atomics are 1 indexed, Abit.Counter counters are 0 indexed. Enumerable protocol Abit.Counter implements the Enumerable protocol, so all Enum functions can be used: iex&gt; c = Abit.Counter . new ( 1000 , 16 , signed : false ) iex&gt; c |&gt; Abit.Counter . put ( 700 , 54321 ) iex&gt; c |&gt; Enum . max ( ) 54321 Examples iex&gt; c = Abit.Counter . new ( 1000 , 8 , signed : false ) iex&gt; c |&gt; Abit.Counter . put ( 0 , 100 ) { :ok , { 0 , 100 } } iex&gt; c |&gt; Abit.Counter . add ( 0 , 100 ) { :ok , { 0 , 200 } } iex&gt; c |&gt; Abit.Counter . add ( 0 , 100 ) { :error , :value_out_of_bounds }","ref":"Abit.Counter.html","title":"Abit.Counter","type":"module"},{"doc":"Increments the value of the counter at index with incr . Returns {:ok, {index, final_value}} or {:error, :value_out_of_bounds} if option wrap_around is false and value is out of bounds. Examples iex&gt; c = Abit.Counter . new ( 10 , 8 ) iex&gt; c |&gt; Abit.Counter . add ( 7 , - 12 ) { :ok , { 7 , - 12 } } iex&gt; c |&gt; Abit.Counter . add ( 7 , 36 ) { :ok , { 7 , 24 } } iex&gt; c |&gt; Abit.Counter . put ( 1 , 1000 ) { :error , :value_out_of_bounds }","ref":"Abit.Counter.html#add/3","title":"Abit.Counter.add/3","type":"function"},{"doc":"Returns the value of counter at index . Examples iex&gt; c = Abit.Counter . new ( 10 , 8 ) iex&gt; c |&gt; Abit.Counter . get ( 7 ) 0","ref":"Abit.Counter.html#get/2","title":"Abit.Counter.get/2","type":"function"},{"doc":"Returns all counters from atomics at index. Index of atomics are one-based. Examples iex&gt; c = Abit.Counter . new ( 100 , 8 ) iex&gt; c |&gt; Abit.Counter . put ( 3 , - 70 ) iex&gt; c |&gt; Abit.Counter . get_all_at_atomic ( 1 ) [ 0 , 0 , 0 , 0 , - 70 , 0 , 0 , 0 ]","ref":"Abit.Counter.html#get_all_at_atomic/2","title":"Abit.Counter.get_all_at_atomic/2","type":"function"},{"doc":"Returns true if any counter has the value integer , false otherwise. Examples iex&gt; c = Abit.Counter . new ( 100 , 8 ) iex&gt; c |&gt; Abit.Counter . member? ( 0 ) true iex&gt; c |&gt; Abit.Counter . member? ( 80 ) false","ref":"Abit.Counter.html#member?/2","title":"Abit.Counter.member?/2","type":"function"},{"doc":"Returns a new %Abit.Counter{} struct. size - minimum number of counters to have, counters will fully fill the :atomics . Check the :size key in the returned %Abit.Counter{} for the exact number of counters counters_bit_size - how many bits a counter should use Options :signed - whether to have signed or unsigned counters. Defaults to true . :wrap_around - whether counters should wrap around. Defaults to false . Examples Abit.Counter . new ( 100 , 8 ) # minimum 100 counters; 8 bits signed Abit.Counter . new ( 10_000 , 16 , signed : false ) # minimum 10_000 counters; 16 bits unsigned Abit.Counter . new ( 10_000 , 16 , wrap_around : false ) # don&#39;t wrap around","ref":"Abit.Counter.html#new/3","title":"Abit.Counter.new/3","type":"function"},{"doc":"Puts the value into the counter at index . Returns {:ok, {index, final_value}} or {:error, :value_out_of_bounds} if option wrap_around is false and value is out of bounds. Examples iex&gt; c = Abit.Counter . new ( 10 , 8 ) iex&gt; c |&gt; Abit.Counter . put ( 7 , - 12 ) { :ok , { 7 , - 12 } } iex&gt; c |&gt; Abit.Counter . get ( 7 ) - 12 iex&gt; c |&gt; Abit.Counter . put ( 7 , 128 ) { :error , :value_out_of_bounds }","ref":"Abit.Counter.html#put/3","title":"Abit.Counter.put/3","type":"function"},{"doc":"","ref":"Abit.Counter.html#t:t/0","title":"Abit.Counter.t/0","type":"type"}]